Ticket #42883

advance_index_iterate(): Move advance_count() call outside the loop

Open Date: 2021-09-19 21:28 Last Update: 2021-09-30 19:50

Reporter:
Owner:
Type:
Status:
Closed
Component:
MileStone:
Priority:
5 - Medium
Severity:
5 - Medium
Resolution:
Fixed
File:
1

Details

advance_index_iterate() terminates when index variable reaches advance_count(). The advance_count() is called for the check each and every round of the iteration. That's a lot of unnecessary function call overhead. We should call it just once, outside the loop, and place the result in a variable to use inside the loop.

There's currently gcc-12 trouble with advance_index_iterate() involved. Maybe we should wait that to get resolved first, though I think it's a compiler, not freeciv, bug. ( Filed https://gcc.gnu.org/bugzilla/show_bug.cgi?id=102405 )

Ticket History (3/5 Histories)

2021-09-19 21:28 Updated by: cazfi
  • New Ticket "advance_index_iterate(): Move advance_count() call outside the loop" created
2021-09-20 06:53 Updated by: cazfi
Comment

Reply To cazfi

There's currently gcc-12 trouble with advance_index_iterate() involved. Maybe we should wait that to get resolved first, though I think it's a compiler, not freeciv, bug.

Gcc considered it not-a-bug, so we have to handle that ourselves -> #42885

2021-09-23 11:52 Updated by: cazfi
  • Resolution Update from None to Accepted
  • Milestone Update from (None) to 2.6.6
2021-09-30 19:50 Updated by: cazfi
  • Status Update from Open to Closed
  • Owner Update from (None) to cazfi
  • Resolution Update from Accepted to Fixed

Edit

You are not logged in. I you are not logged in, your comment will be treated as an anonymous post. » Login